#!/usr/bin/python
from taskmanager import *

from Queue import Queue


class LoggingThread(object):
    """Send stdout data to hub in a background thread."""
    __slots__ = (
        "hub",
        "task_id",
        "queue",
        "terminate",
        "last_sent",
        "data_to_send",
    )


    def __init__(self, hub, task_id, queue, *args, **kwargs):
#        threading.Thread.__init__(self, *args, **kwargs)
        self.hub = hub
        self.task_id = task_id
        self.queue = queue
        self.terminate = False
        self.last_sent = datetime.datetime.now()
        self.data_to_send = ""


    def _has_data_to_send(self, force):
        if force:
            return True
        if self.data_to_send:
            return True
        if self.queue.qsize() > 500:
            return True
        if not self.queue.empty() and (datetime.datetime.now() > self.last_sent + datetime.timedelta(seconds=20)):
            return True
        return False


    def send(self, force=False):
        if self._has_data_to_send(force):
            while True:
                try:
                    self.data_to_send += self.queue.get(block=False)
                except Queue.Empty:
                    break

            try:
                self.hub.upload_task_log(StringIO(self.data_to_send), self.task_id, "stdout.log", append=True)
            except Fault:
                # send failed, keep data for the next send() call
                pass
            else:
                self.data_to_send = ""


    def finish(self):
        for i in xrange(3):
            if self.send(force=True):
                return True
            time.sleep(1)
        return False

q = Queue()
t = LoggingThread(